package edu.ntua.ivml.qa.algorithm;

import edu.ntua.ivml.qa.db.QueryCollector;
import edu.ntua.ivml.qa.dllite.DLLiteRTheory;
import edu.ntua.ivml.qa.lp.Clause;


public abstract class Engine extends Thread {

	public static boolean removeRedundant = false;
	
	protected String name;
	
	protected long lastTime;
	
	protected DLLiteRTheory lp;
	protected Clause query;
	
	protected QueryCollector qc;

	protected Engine(String name) {
		this.name = name;
	}
	
	public String getEngineName() {
		return name;
	}
	
	public void setTheory(DLLiteRTheory lp) {
		this.lp = lp;
	}

	public QueryCollector createQueryCollector(Clause query) {
		this.query = query.condenseWithOriginalVariables();
		
		qc = new QueryCollector(query);

		return qc;
	}

	public QueryCollector getQueryCollector() {
		return qc;
	}
	
	public abstract void execute();
	
	public long getLastExecutionTime() {
		return lastTime;
	}
	
	public void run() {
		
		try {
			long sTime = System.currentTimeMillis();
			execute();
			lastTime = System.currentTimeMillis() - sTime;
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public ExecutionResult computeRewritings(Clause query) {
		
		QueryCollector qc = createQueryCollector(query);
	
		execute();
	
		return new ExecutionResult(qc.getNonRedundantQueries());
	}

	
}
