package edu.ntua.ivml.qa.algorithm.rapid;

import java.util.Set;

import edu.ntua.ivml.qa.lp.Atom;
import edu.ntua.ivml.qa.lp.Function;
import edu.ntua.ivml.qa.utils.SetUtils;


public class AtomUnfoldList {
	public Atom[] list;
	private Set<Function> arg0Functions;
	private Set<Function> arg1Functions;
	
	public AtomUnfoldList(Atom[] list) {
		this.list = list;
	}
	
	public AtomUnfoldList(Atom[] list, Set<Function> arg0Functions, Set<Function> arg1Functions) {
		this.list = list;
		this.arg0Functions = arg0Functions;
		this.arg1Functions = arg1Functions;
	}
	
	public Atom[] getAtoms() {
		return list;
	}
	
	public boolean isUnfolding(Atom atom) {
		for (Atom a: list) {
			if (atom.equals(a)) {
				return true;
			}
		}
		
		return false;
	}
	
	public Set<Function> getFunctions() {
		return SetUtils.union(arg0Functions, arg1Functions);
	}
	
	public Set<Function> getFunctions(int arg) {
		if (arg == 0) {
			return arg0Functions;
		} else {
			return arg1Functions;
		}
	}
	
	public String toString() {
		String s = "";
		for (Atom a : list) {
			s += a + "\n";
		}
		s += "(" + arg0Functions + ", " + arg1Functions + ")"; 

		return s;
	}
}
