package edu.ntua.ivml.qa.dllite;

import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.model.IRI;
import org.semanticweb.owlapi.model.OWLNamedObject;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyCreationException;
import org.semanticweb.owlapi.model.OWLOntologyManager;
import org.semanticweb.owlapi.model.PrefixManager;
import org.semanticweb.owlapi.vocab.PrefixOWLOntologyFormat;

public class OntologyReference {

	public OWLOntologyManager manager;
	public OWLOntology ontology;
	
	private PrefixOWLOntologyFormat prefixFormat;

	public OntologyReference(String path) throws OWLOntologyCreationException {
		this(IRI.create(path));
	}
	
	public OntologyReference(IRI iri) throws OWLOntologyCreationException {
		
		manager = OWLManager.createOWLOntologyManager(); 
		ontology = manager.loadOntologyFromOntologyDocument(iri);
		
		prefixFormat =	manager.getOntologyFormat(ontology).asPrefixOWLOntologyFormat();

	}
	
	public PrefixManager getPrefixFormat() {
		return prefixFormat;
	}

	public String handleIRI(OWLNamedObject obj) {

		String s  = prefixFormat.getPrefixIRI(obj.getIRI());
		if (s == null) {
			s = obj.getIRI().toString();
		}
		if (s.startsWith(":")) {
			s = s.substring(1);
		}
		
		if (obj.getIRI().getFragment() == null) {
			return s;
		} else {
			return obj.getIRI().getFragment().toString();
		}
	}
	
	public OWLOntology getOntology() {
		return ontology;
	}
}
